#define	TAPS		5
#define	STEPSIZE	0.01

.GLOBAL	lms_init, lms_alg;

.SEGMENT/DM    seg_pmda;
.VAR	deline_data[TAPS];
.ENDSEG;

.SEGMENT/PM     seg_dmda;
.VAR	weights[TAPS];
.ENDSEG;

.SEGMENT/PM     seg_pmco;
lms_init:	b0=deline_data;
		m0=-1;
		l0=TAPS;
		b8=weights;
		b9=b8;
		m8=1;
		l8=TAPS;
		l9=l8;
		f7=STEPSIZE;
		f0=0.0;
		lcntr=TAPS, do clear_bufs until lce;
clear_bufs:	  dm(i0,m0)=f0, pm(i8,m8)=f0;
		rts;
lms_init.end:


lms_alg:	dm(i0,m0)=f0, f4=pm(i8,m8);
		f8=f0*f4, f0=dm(i0,m0), f4=pm(i8,m8);
		f12=f0*f4, f0=dm(i0,m0), f4= pm(i8,m8);
		lcntr=TAPS-3, do macs until lce;
macs:		  f12=f0*f4, f8=f8+f12, f0=dm(i0,m0), f4= pm(i8,m8);
		f12=f0*f4, f8=f8+f12;
		f13=f8+f12;
		f6=f1-f13;
		f1=f6*f7, f4=dm(i0,m0);
		f0=f1*f4, f12=pm(i8,m8);
		lcntr=TAPS-1, do update_weights until lce;
		  f8=f0+f12, f4=dm(i0,m0), f12=pm(i8,m8);
update_weights:   f0=f1*f4, pm(i9,m8)=f8;
		rts(db);
		f8=f0+f12, f0=dm(i0,1);
		pm(i9,m8)=f8;

lms_alg.end:
.ENDSEG;

